Index: /readTracFiles_mod.f90
===================================================================
--- /readTracFiles_mod.f90	(revision 1)
+++ /readTracFiles_mod.f90	(revision 2)
@@ -1,7 +1,7 @@
 MODULE readTracFiles_mod
 
-  USE strings_mod, ONLY: msg, testFile,  strFind, strStack, strReduce,  strHead, strCount,   find, dispTable, fmsg, &
-          removeComment, cat, checkList, strIdx,  strParse, strReplace, strTail, reduceExpr, test, modname, get_in
-  USE trac_types_mod, ONLY : tra, iso, db, kys
+  USE strings_mod, ONLY:   msg, testFile,  strFind, strStack, strReduce,  strHead, strCount,   find, maxlen, fmsg, &
+            removeComment, cat, checkList, strIdx,  strParse, strReplace, strTail, reduceExpr, test, get_in, dispTable
+  USE trac_types_mod, ONLY : trac_type, isot_type, keys_type
 
   IMPLICIT NONE
@@ -10,18 +10,18 @@
 
   PUBLIC :: initIsotopes
-  PUBLIC :: readTracersFiles, aliasTracer, tracersSubset, indexUpdate     !--- TOOLS ASSOCIATED TO TRACERS  DESCRIPTORS
-  PUBLIC :: readIsotopesFile                                              !--- TOOLS ASSOCIATED TO ISOTOPES DESCRIPTORS
-  PUBLIC :: getKey_init, getKey, setDirectKeys                            !--- FUNCTIONS TO GET KEYS FROM tracers & isotopes
-
-  PUBLIC :: known_phases, old_phases, nphases, phases_names, phases_sep, &!--- VARIABLES RELATED TO THE PHASES
-            delPhase, addPhase                                            !--- ROUTINES TO ADD/REMOVE PHASE TO/FROM A NAME
-
-  PUBLIC :: tran0, idxAncestor, ancestor                                  !--- GEN 0 TRACER + TOOLS FOR GENERATIONS
-
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE db                                                            !=== TYPE FOR TRACERS SECTION
-    CHARACTER(LEN=256)     :: name                                   !--- Section name
-    TYPE(tra), ALLOCATABLE :: trac(:)                                !--- Tracers descriptors
-  END TYPE db
+  PUBLIC :: readTracersFiles, aliasTracer, tracersSubset, indexUpdate!--- TOOLS ASSOCIATED TO TRACERS  DESCRIPTORS
+  PUBLIC :: readIsotopesFile                                         !--- TOOLS ASSOCIATED TO ISOTOPES DESCRIPTORS
+  PUBLIC :: getKey_init, getKey, setDirectKeys                       !--- GET/SET KEYS FROM/TO tracers & isotopes
+
+  PUBLIC :: known_phases, old_phases, nphases, phases_names, &       !--- VARIABLES RELATED TO THE PHASES
+            phases_sep, delPhase, addPhase                           !--- + ROUTINES TO ADD/REMOVE PHASE TO/FROM A NAME
+
+  PUBLIC :: tran0, idxAncestor, ancestor                             !--- GENERATION 0 TRACER + TOOLS FOR GENERATIONS
+
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE :: dataBase_type                                              !=== TYPE FOR TRACERS SECTION
+    CHARACTER(LEN=maxlen)  :: name                                   !--- Section name
+    TYPE(trac_type), ALLOCATABLE :: trac(:)                          !--- Tracers descriptors
+  END TYPE dataBase_type
 !------------------------------------------------------------------------------------------------------------------------------
   INTERFACE getKey
@@ -29,5 +29,5 @@
   END INTERFACE getKey
 !------------------------------------------------------------------------------------------------------------------------------
-  INTERFACE tracersSubset; MODULE PROCEDURE trSubset_Indx, trSubset_Name, trSubset_Nam1; END INTERFACE tracersSubset
+  INTERFACE tracersSubset; MODULE PROCEDURE trSubset_Indx, trSubset_Name, trSubset_gen0Name; END INTERFACE tracersSubset
   INTERFACE idxAncestor;   MODULE PROCEDURE idxAncestor_1, idxAncestor_m; END INTERFACE idxAncestor
   INTERFACE    ancestor;   MODULE PROCEDURE    ancestor_1,    ancestor_m; END INTERFACE    ancestor
@@ -36,13 +36,13 @@
 
   !=== MAIN DATABASE: files sections descriptors
-  TYPE(db), SAVE, ALLOCATABLE, TARGET :: dBase(:)
+  TYPE(dataBase_type), SAVE, ALLOCATABLE, TARGET :: dBase(:)
 
   !--- SOME PARAMETERS THAT ARE NOT LIKELY TO CHANGE OFTEN
-  CHARACTER(LEN=256), SAVE      :: tran0        = 'air'              !--- Default transporting fluid
-  CHARACTER(LEN=256), PARAMETER :: old_phases   = 'vli'              !--- Old phases for water (no separator)
-  CHARACTER(LEN=256), PARAMETER :: known_phases = 'gls'              !--- Known phases initials
-  INTEGER,            PARAMETER :: nphases = LEN_TRIM(known_phases)  !--- Number of phases
-  CHARACTER(LEN=256), SAVE      :: phases_names(nphases) &           !--- Known phases names
-                                 = ['gaseous', 'liquid ', 'solid  ']
+  CHARACTER(LEN=maxlen), SAVE      :: tran0        = 'air'           !--- Default transporting fluid
+  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vli'           !--- Old phases for water (no separator)
+  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'gls'           !--- Known phases initials
+  INTEGER,               PARAMETER :: nphases=LEN_TRIM(known_phases) !--- Number of phases
+  CHARACTER(LEN=maxlen), SAVE      :: phases_names(nphases) &        !--- Known phases names
+                                = ['gaseous', 'liquid ', 'solid  ']
   CHARACTER(LEN=1),   SAVE      :: phases_sep  =  '_'                !--- Phase separator
   LOGICAL,            SAVE      :: tracs_merge = .TRUE.              !--- Merge/stack tracers lists
@@ -50,7 +50,8 @@
 
   !=== LOCAL COPIES OF THE TRACERS AND ISOTOPES DESCRIPTORS, USED BY getKey (INITIALIZED IN getKey_init)
-  TYPE(tra), ALLOCATABLE, TARGET, SAVE ::  tracers(:)
-  TYPE(iso), ALLOCATABLE, TARGET, SAVE :: isotopes(:)
-
+  TYPE(trac_type), ALLOCATABLE, TARGET, SAVE ::  tracers(:)
+  TYPE(isot_type), ALLOCATABLE, TARGET, SAVE :: isotopes(:)
+
+  CHARACTER(LEN=maxlen) :: modname
 
 CONTAINS
@@ -73,23 +74,23 @@
 !=== FUNCTION RETURN VALUE "lerr" IS FALSE IN CASE SOMETHING WENT WRONG.
 !=== ABOUT THE KEYS:
-!     * The "keys" component (of type kys) is in principle enough to store everything we could need.
+!     * The "keys" component (of type keys_type) is in principle enough to store everything we could need.
 !     But some variables are stored as direct-access keys to make the code more readable and because they are used often.
 !     * Most of the direct-access keys are set in this module, but some are not (lnam, iadv and itr for example).
 !     * Some of the direct-access keys must be updated (using the routine "setDirectKeys") is a subset of "tracers(:)"
-!     is extracted: the indexes are no longer valid for a subset (examples: tracers(:)iprnt or tracers(:)%ichld).
+!     is extracted: the indexes are no longer valid for a subset (examples: tracers(:)%iqParent or tracers(:)%ichld).
 !     * If you need to convert a %key/%val pair into a direct-access key, add the corresponding line in "setDirectKeys".
 !==============================================================================================================================
 LOGICAL FUNCTION readTracersFiles(type_trac, fType, tracs) RESULT(lerr)
 !------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=*),       INTENT(IN)  :: type_trac                    !--- List of components used
-  INTEGER,                INTENT(OUT) :: fType                        !--- Type of input file found
-  TYPE(tra), ALLOCATABLE, INTENT(OUT) :: tracs(:)
-  CHARACTER(LEN=256),     ALLOCATABLE ::  s(:), sections(:), trac_files(:)
-  CHARACTER(LEN=256)   :: str, fname, mesg
-  INTEGER              :: is, nsec, ierr, it, ntrac, ns, ip
-  LOGICAL, ALLOCATABLE :: ll(:), lGen3(:)
+  CHARACTER(LEN=*),             INTENT(IN)  :: type_trac              !--- List of components used
+  INTEGER,                      INTENT(OUT) :: fType                  !--- Type of input file found
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: tracs(:)
+  CHARACTER(LEN=maxlen),  ALLOCATABLE ::  s(:), sections(:), trac_files(:)
+  CHARACTER(LEN=maxlen) :: str, fname, mesg
+  INTEGER               :: is, nsec, ierr, it, ntrac, ns, ip
+  LOGICAL, ALLOCATABLE  :: ll(:), lGen3(:)
 !------------------------------------------------------------------------------------------------------------------------------
   lerr = .FALSE.
-!  modname = 'readTracersFiles'
+  modname = 'readTracersFiles'
   IF(.NOT.ALLOCATED(dBase)) ALLOCATE(dBase(0))
 
@@ -111,8 +112,8 @@
 
   !--- TELLS WHAT WAS IS ABOUT TO BE USED
-  IF( fmsg(fType==0, 'No adequate tracers description file(s) found ; default values will be used')) RETURN
-  CALL msg(fType==1, 'Trying to read old-style tracers description file "traceur.def"')
-  CALL msg(fType==2, 'Trying to read the new style multi-sections tracers description file "tracer.def"')
-  CALL msg(fType==3, 'Trying to read the new style single section tracers description files "tracer_*.def"')
+  IF (fmsg('No adequate tracers description file(s) found ; default values will be used',          modname, fType==0)) RETURN
+  CALL msg('Trying to read old-style tracers description file "traceur.def"',                      modname, fType==1)
+  CALL msg('Trying to read the new style multi-sections tracers description file "tracer.def"',    modname, fType==2)
+  CALL msg('Trying to read the new style single section tracers description files "tracer_*.def"', modname, fType==3)
 
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -124,5 +125,5 @@
     !--- GET THE TRACERS NUMBER
     READ(90,'(i3)',IOSTAT=ierr)ntrac                                 !--- Number of lines/tracers
-    IF(test(fmsg(ierr /= 0, 'Invalid format for "'//TRIM(fname)//'"'), lerr)) RETURN
+    IF(test(fmsg('Invalid format for "'//TRIM(fname)//'"', modname, ierr /= 0), lerr)) RETURN
 
     !--- READ THE REMAINING LINES: <hadv> <vadv> <tracer> [<transporting fluid>]
@@ -130,23 +131,23 @@
     DO it=1,ntrac                                                    !=== READ RAW DATA: loop on the line/tracer number
       READ(90,'(a)',IOSTAT=ierr) str
-      IF(test(fmsg(ierr>0, 'Invalid format for "' //TRIM(fname)//'"'), lerr)) RETURN
-      IF(test(fmsg(ierr<0, 'Not enough lines in "'//TRIM(fname)//'"'), lerr)) RETURN
+      IF(test(fmsg('Invalid format for "' //TRIM(fname)//'"', modname, ierr>0), lerr)) RETURN
+      IF(test(fmsg('Not enough lines in "'//TRIM(fname)//'"', modname, ierr<0), lerr)) RETURN
       ll = strParse(str, ' ', s, n=ns)
       tracs(it)%keys%key = ['hadv', 'vadv']
       tracs(it)%keys%val = s(1:2)
-      CALL msg(ns == 3 .AND. it == 1, 'This file is for air tracers only')
-      CALL msg(ns == 4 .AND. it == 1, 'This files specifies the transporting fluid')
-      tracs(it)%name = s(3); tracs(it)%phas = known_phases(1:1)      !--- Default: name, gazeous phase "g"
+      CALL msg('This file is for air tracers only',           modname, ns == 3 .AND. it == 1)
+      CALL msg('This files specifies the transporting fluid', modname, ns == 4 .AND. it == 1)
+      tracs(it)%name = s(3); tracs(it)%phase = known_phases(1:1)     !--- Default: name, gazeous phase "g"
       DO ip = 1, nphases                                             !--- Deal with old water names
         IF(s(3) /= 'H2O'//old_phases(ip:ip)) CYCLE
-        tracs(it)%phas = known_phases(ip:ip); tracs(it)%name = 'H2O'//phases_sep//TRIM(tracs(it)%phas)
+        tracs(it)%phase = known_phases(ip:ip); tracs(it)%name = 'H2O'//phases_sep//TRIM(tracs(it)%phase)
       END DO
-      tracs(it)%prnt = tran0                                         !--- Default transporting fluid: Air
-      IF(ns == 4) tracs(it)%prnt = s(4)                              !--- Transporting fluid name
+      tracs(it)%parent = tran0                                       !--- Default transporting fluid: Air
+      IF(ns == 4) tracs(it)%parent = s(4)                            !--- Transporting fluid name
     END DO
     CLOSE(90)
 
-    lGen3 = tracs%igen==3
-    CALL setGeneration(tracs)                                        !--- Determine tracs(:)%igen values
+    lGen3 = tracs%iGeneration==3
+    CALL setGeneration(tracs)                                        !--- Determine tracs(:)%iGeneration values
     IF(test(checkTracers(tracs,      fname,fname),lerr)) RETURN      !--- Detect orphans and check phases
     IF(test(checkUnique (tracs,lGen3,fname,fname),lerr)) RETURN      !--- Detect repeated tracers
@@ -160,6 +161,6 @@
 
   !=== USING NEW FORMAT TRACERS DESCRIPTION FILES WITH POSSIBLY SEVERAL SECTIONS
-  CALL msg(nsec > 1 .AND.      tracs_merge, 'The multiple required sections will be MERGED.')
-  CALL msg(nsec > 1 .AND. .NOT.tracs_merge, 'The multiple required sections will be CUMULATED.')
+  CALL msg('The multiple required sections will be MERGED.',    modname, nsec > 1 .AND.      tracs_merge)
+  CALL msg('The multiple required sections will be CUMULATED.', modname, nsec > 1 .AND. .NOT.tracs_merge)
 
   !=== FEED THE DATABASE WITH THE RAW CONTENT OF THE FILE
@@ -191,9 +192,9 @@
   INTEGER,  ALLOCATABLE :: ixf(:)                                    !--- File index for each section of the expanded list
   LOGICAL,  ALLOCATABLE :: lTg(:)                                    !--- Tagging tracers mask
-  CHARACTER(LEN=256)    :: fnm, snm
+  CHARACTER(LEN=maxlen) :: fnm, snm, modname
   INTEGER               :: idb, i
   LOGICAL :: ll
 !------------------------------------------------------------------------------------------------------------------------------
-
+  modname = 'feedDBase'
   !=== READ THE REQUIRED SECTIONS
   ll = strCount(snames, ',', ndb)                                    !--- Number of sections for each file
@@ -219,5 +220,6 @@
 
   !=== DISPLAY BASIC INFORMATION
-  lerr = ANY([(dispTraSection('Expanded list for section "'//TRIM(dBase(idb)%name)//'"',dBase(idb)%name), idb=1, SIZE(dBase))])
+  lerr = ANY([( dispTraSection('Expanded list for section "'//TRIM(dBase(idb)%name)//'"', dBase(idb)%name, modname), &
+                idb=1, SIZE(dBase) )])
 END FUNCTION feedDBase
 !------------------------------------------------------------------------------------------------------------------------------
@@ -230,7 +232,7 @@
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: defName                  !--- Special section (default values) name
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(db),           ALLOCATABLE :: tdb(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: sec(:)
-  INTEGER,            ALLOCATABLE ::  ix(:)
+  TYPE(dataBase_type),   ALLOCATABLE :: tdb(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: sec(:)
+  INTEGER,               ALLOCATABLE ::  ix(:)
   INTEGER :: n0, idb, ndb, i, j
   LOGICAL :: ll
@@ -252,10 +254,10 @@
 SUBROUTINE readSections_all()
 !------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=256), ALLOCATABLE ::  s(:), v(:)
-  TYPE(tra),          ALLOCATABLE :: tt(:)
-  TYPE(tra)           :: tmp
-  CHARACTER(LEN=1024) :: str
-  CHARACTER(LEN=256)  :: secn
-  INTEGER             :: ierr, n
+  CHARACTER(LEN=maxlen), ALLOCATABLE ::  s(:), v(:)
+  TYPE(trac_type),       ALLOCATABLE :: tt(:)
+  TYPE(trac_type)       :: tmp
+  CHARACTER(LEN=1024)   :: str
+  CHARACTER(LEN=maxlen) :: secn
+  INTEGER               :: ierr, n
 !------------------------------------------------------------------------------------------------------------------------------
   IF(.NOT.ALLOCATED(dBase)) ALLOCATE(dBase(0))
@@ -280,8 +282,8 @@
       ll = strParse(str,' ', keys = s, vals = v, n = n)              !--- Parse <key>=<val> pairs
       tt = dBase(ndb)%trac(:)
-      tmp%name = s(1); tmp%comp=secn; tmp%keys = kys(s(1), s(2:n), v(2:n))
+      tmp%name = s(1); tmp%component=secn; tmp%keys = keys_type(s(1), s(2:n), v(2:n))
       dBase(ndb)%trac = [tt(:), tmp]
       DEALLOCATE(tt)
-!      dBase(ndb)%trac = [dBase(ndb)%trac(:), tra(name=s(1), comp=secn, keys=kys(s(1), s(2:n), v(2:n)))]
+!      dBase(ndb)%trac = [dBase(ndb)%trac(:), tra(name=s(1), comp=secn, keys=keys_type(s(1), s(2:n), v(2:n)))]
     END IF
   END DO
@@ -300,9 +302,9 @@
 ! Purpose: Add the keys from virtual tracer named "defName" (if any) and remove this virtual tracer.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
-  CHARACTER(LEN=*),               INTENT(IN)    :: defName
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
+  CHARACTER(LEN=*),                     INTENT(IN)    :: defName
   INTEGER :: jd, it, k
-  TYPE(kys), POINTER :: ky
-  TYPE(tra), ALLOCATABLE :: tt(:)
+  TYPE(keys_type), POINTER :: ky
+  TYPE(trac_type), ALLOCATABLE :: tt(:)
   jd = strIdx(t(:)%name, defName)
   IF(jd == 0) RETURN
@@ -321,10 +323,10 @@
 !          Substitute the keys locally (for the current tracer) if the flag "lSubLocal" is .TRUE.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
-  CHARACTER(LEN=*),               INTENT(IN)    :: defName
-  LOGICAL,                        INTENT(IN)    :: lSubLocal
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
+  CHARACTER(LEN=*),                     INTENT(IN)    :: defName
+  LOGICAL,                              INTENT(IN)    :: lSubLocal
   INTEGER :: i0, it, ik
-  TYPE(kys), POINTER     :: k0, ky
-  TYPE(tra), ALLOCATABLE :: tt(:)
+  TYPE(keys_type), POINTER     :: k0, ky
+  TYPE(trac_type), ALLOCATABLE :: tt(:)
   i0 = strIdx(t(:)%name, defName)
   IF(i0 == 0) RETURN
@@ -353,12 +355,13 @@
 !        * Default values are provided for these keys because they are necessary.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra),     ALLOCATABLE, INTENT(INOUT) :: tr(:)                 !--- Tracer derived type vector
-  CHARACTER(LEN=*),           INTENT(IN)    :: sname
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN)    :: fname
-  TYPE(tra),          ALLOCATABLE :: ttr(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: ta(:), pa(:)
-  CHARACTER(LEN=256) :: msg1
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)                 !--- Tracer derived type vector
+  CHARACTER(LEN=*),             INTENT(IN)    :: sname
+  CHARACTER(LEN=*), OPTIONAL,   INTENT(IN)    :: fname
+  TYPE(trac_type),       ALLOCATABLE :: ttr(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: ta(:), pa(:)
+  CHARACTER(LEN=maxlen) :: msg1, modname
   INTEGER :: it, nt, iq, nq, itr, ntr, ipr, npr, i
   LOGICAL :: ll
+  modname = 'expandSection'
   lerr = .FALSE.
   nt = SIZE(tr)
@@ -368,11 +371,11 @@
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     !--- Extract useful keys: parent name, type, component name
-    tr(it)%prnt = fgetKey(it, 'parent', tr(:)%keys,  tran0  )
-    tr(it)%type = fgetKey(it, 'type'  , tr(:)%keys, 'tracer')
-    tr(it)%comp = sname
+    tr(it)%parent    = fgetKey(it, 'parent', tr(:)%keys,  tran0  )
+    tr(it)%type      = fgetKey(it, 'type'  , tr(:)%keys, 'tracer')
+    tr(it)%component = sname
 
     !--- Determine the number of tracers and parents ; coherence checking
-    ll = strCount(tr(it)%name, ',', ntr)
-    ll = strCount(tr(it)%prnt, ',', npr)
+    ll = strCount(tr(it)%name,   ',', ntr)
+    ll = strCount(tr(it)%parent, ',', npr)
 
     !--- Tagging tracers only can have multiple parents
@@ -380,5 +383,5 @@
       msg1 = 'Check section "'//TRIM(sname)//'"'
       IF(PRESENT(fname)) msg1=TRIM(msg1)//' in file "'//TRIM(fname)//'"'
-      CALL msg(TRIM(msg1)//': "'//TRIM(tr(it)%name)//'" has several parents but is not a tag'); RETURN
+      CALL msg(TRIM(msg1)//': "'//TRIM(tr(it)%name)//'" has several parents but is not a tag', modname); RETURN
     END IF
     nq = nq + ntr*npr                 
@@ -394,10 +397,10 @@
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     ll = strParse(tr(it)%name, ',', ta, n=ntr)                       !--- Number of tracers
-    ll = strParse(tr(it)%prnt, ',', pa, n=npr)                       !--- Number of parents
+    ll = strParse(tr(it)%parent, ',', pa, n=npr)                     !--- Number of parents
     DO ipr=1,npr                                                     !--- Loop on parents list elts
       DO itr=1,ntr                                                   !--- Loop on tracers list elts
         i = iq+itr-1+(ipr-1)*ntr
-        ttr(i)%name = ta(itr); ttr(i)%prnt = pa(ipr)
-        ttr(i)%keys = kys(ta(itr), tr(it)%keys%key, tr(it)%keys%val)
+        ttr(i)%name = ta(itr); ttr(i)%parent = pa(ipr)
+        ttr(i)%keys = keys_type(ta(itr), tr(it)%keys%key, tr(it)%keys%val)
       END DO
     END DO
@@ -421,25 +424,25 @@
 !------------------------------------------------------------------------------------------------------------------------------
 ! Arguments:
-  TYPE(tra), INTENT(INOUT) :: tr(:)                                  !--- Tracer derived type vector
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)                            !--- Tracer derived type vector
 !------------------------------------------------------------------------------------------------------------------------------
 ! Local variables:
   INTEGER :: iq, nq, ig
-  LOGICAL,            ALLOCATABLE :: lg(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: prn(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  tr(:)%igen = 0                                                     !--- error if 0
+  LOGICAL,               ALLOCATABLE :: lg(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: prn(:)
+!------------------------------------------------------------------------------------------------------------------------------
+  tr(:)%iGeneration = 0                                              !--- error if 0
   nq = SIZE(tr, DIM=1)                                               !--- Number of tracers lines
-  lg = tr(:)%prnt == tran0                                           !--- First generation tracers flag
-  WHERE(lg) tr(:)%igen = 1                                           !--- First generation tracers
+  lg = tr(:)%parent == tran0                                         !--- First generation tracers flag
+  WHERE(lg) tr(:)%iGeneration = 1                                    !--- First generation tracers
 
   !=== Determine generation for each tracer
   ig=0; prn = [tran0]
   DO                                                                 !--- Update current generation flag
-    IF(ig/=0) prn = PACK( tr(:)%name, MASK=tr(:)%igen == ig)
-    lg(:) = [(ANY(prn(:) == tr(iq)%prnt), iq=1, nq)]                 !--- Current generation tracers flag
+    IF(ig/=0) prn = PACK( tr(:)%name, MASK=tr(:)%iGeneration == ig)
+    lg(:) = [(ANY(prn(:) == tr(iq)%parent), iq=1, nq)]               !--- Current generation tracers flag
     IF( ALL( .NOT. lg ) ) EXIT                                       !--- Empty current generation
-    ig = ig+1; WHERE(lg) tr(:)%igen = ig
-  END DO
-  tr(:)%nam1 = ancestor(tr)                                          !--- First generation ancestor name
+    ig = ig+1; WHERE(lg) tr(:)%iGeneration = ig
+  END DO
+  tr(:)%gen0Name = ancestor(tr)                                      !--- First generation ancestor name
 
 END SUBROUTINE setGeneration
@@ -453,9 +456,9 @@
 !   * check wether the phases are known or not ("g"aseous, "l"iquid or "s"olid so far)
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra),                  INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
+  TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fname                    !--- File name
-  CHARACTER(LEN=256) :: mesg
-  CHARACTER(LEN=256) :: bp(SIZE(tr, DIM=1)), pha                     !--- Bad phases list, phases of current tracer
+  CHARACTER(LEN=maxlen) :: mesg
+  CHARACTER(LEN=maxlen) :: bp(SIZE(tr, DIM=1)), pha                  !--- Bad phases list, phases of current tracer
   CHARACTER(LEN=1) :: p
   INTEGER :: ip, np, iq, nq
@@ -466,8 +469,8 @@
 
   !=== CHECK FOR ORPHAN TRACERS
-  IF(test(checkList(tr%name, tr%igen==0, mesg, 'tracers', 'orphan'), lerr)) RETURN
+  IF(test(checkList(tr%name, tr%iGeneration==0, mesg, 'tracers', 'orphan'), lerr)) RETURN
 
   !=== CHECK PHASES
-  DO iq=1,nq; IF(tr(iq)%igen/=1) CYCLE                               !--- Generation 1 only is checked
+  DO iq=1,nq; IF(tr(iq)%iGeneration/=1) CYCLE                        !--- Generation 1 only is checked
     pha = fgetKey(iq, 'phases', tr(:)%keys, 'g')                     !--- Phases
     np = LEN_TRIM(pha); bp(iq)=' '
@@ -475,5 +478,5 @@
     IF(TRIM(bp(iq)) /= '') bp(iq) = TRIM(tr(iq)%name)//': '//TRIM(bp(iq))
   END DO
-  lerr = checkList(bp, tr%igen==1 .AND. bp/='', mesg, 'tracers phases', 'unknown')
+  lerr = checkList(bp, tr%iGeneration==1 .AND. bp/='', mesg, 'tracers phases', 'unknown')
 END FUNCTION checkTracers
 !==============================================================================================================================
@@ -484,5 +487,5 @@
 ! Purpose: Make sure that tracers are not repeated.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra),                  INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
+  TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
   LOGICAL,                    INTENT(IN) :: lTag(:)                  !--- Tagging tracer flag
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
@@ -490,7 +493,7 @@
 !------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: ip, np, iq, nq, k
-  LOGICAL, ALLOCATABLE :: ll(:)
-  CHARACTER(LEN=256) :: mesg, tnam, tdup(SIZE(tr,DIM=1))
-  CHARACTER(LEN=1)   :: p
+  LOGICAL, ALLOCATABLE  :: ll(:)
+  CHARACTER(LEN=maxlen) :: mesg, tnam, tdup(SIZE(tr,DIM=1))
+  CHARACTER(LEN=1)      :: p
 !------------------------------------------------------------------------------------------------------------------------------
   mesg = 'Check section "'//TRIM(sname)//'"'
@@ -502,5 +505,5 @@
     ll = tr(:)%name==tnam                                            !--- Mask for current tracer name
     IF(COUNT(ll)==1 ) CYCLE                                          !--- Tracer is not repeated
-    IF(tr(iq)%igen>1) THEN
+    IF(tr(iq)%iGeneration>1) THEN
       tdup(iq) = tnam                                                !--- gen>1: MUST be unique
     ELSE
@@ -524,9 +527,9 @@
 ! Purpose: Expand the phases in the tracers descriptor "tr".
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE, INTENT(INOUT) :: tr(:)                     !--- Tracer derived type vector
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE :: ttr(:)
-  INTEGER,  ALLOCATABLE ::  i0(:)
-  CHARACTER(LEN=256)    :: nam, pha, trn
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracer derived type vector
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE(trac_type), ALLOCATABLE :: ttr(:)
+  INTEGER,   ALLOCATABLE ::  i0(:)
+  CHARACTER(LEN=maxlen)  :: nam, pha, trn
   INTEGER :: ip, np, iq, jq, nq, it, nt, nc, i, n
   LOGICAL :: lTg, lEx
@@ -535,8 +538,8 @@
   nt = 0
   DO iq = 1, nq                                                      !--- GET THE NUMBER OF TRACERS
-    IF(tr(iq)%igen /= 1) CYCLE
-    nc = COUNT(tr(:)%nam1==tr(iq)%name .AND. tr%igen/=1)             !--- Number of childs of tr(iq)
-    tr(iq)%phas = fgetKey(iq, 'phases', tr(:)%keys)                  !--- Phases list      of tr(iq)
-    np = LEN_TRIM(tr(iq)%phas)                                       !--- Number of phases of tr(iq)
+    IF(tr(iq)%iGeneration /= 1) CYCLE
+    nc = COUNT(tr(:)%gen0Name==tr(iq)%name .AND. tr%iGeneration/=1)  !--- Number of childs of tr(iq)
+    tr(iq)%phase = fgetKey(iq, 'phases', tr(:)%keys)                 !--- Phases list      of tr(iq)
+    np = LEN_TRIM(tr(iq)%phase)                                      !--- Number of phases of tr(iq)
     nt = nt + (1+nc) * np                                            !--- Number of tracers after expansion
   END DO
@@ -545,15 +548,15 @@
   DO iq = 1, nq                                                      !--- Loop on "tr(:)" indexes
     lTg = tr(iq)%type=='tag'                                         !--- Current tracer is a tag
-    i0 = strFind(tr(:)%name, tr(iq)%nam1, n)                         !--- Indexes of first generation ancestor copies
-    np = SUM( [( LEN_TRIM(tr(i0(i))%phas),i=1,n )],1)                !--- Number of phases for current tracer tr(iq)
+    i0 = strFind(tr(:)%name, tr(iq)%gen0Name, n)                     !--- Indexes of first generation ancestor copies
+    np = SUM( [( LEN_TRIM(tr(i0(i))%phase),i=1,n )],1)               !--- Number of phases for current tracer tr(iq)
     lEx = np>1                                                       !--- Need of a phase suffix
-    IF(lTg) lEx=lEx.AND.tr(iq)%igen>1                                !--- No phase suffix for first generation tags
+    IF(lTg) lEx=lEx.AND.tr(iq)%iGeneration>1                         !--- No phase suffix for first generation tags
     DO i=1,n                                                         !=== LOOP ON FIRST GENERATION ANCESTORS
       jq=i0(i)                                                       !--- tr(jq): ith copy of 1st gen. ancestor of tr(iq)
-      IF(tr(iq)%igen==1) jq=iq                                       !--- Generation 1: current tracer phases only
-      pha = tr(jq)%phas                                              !--- Phases list for tr(jq)
+      IF(tr(iq)%iGeneration==1) jq=iq                                !--- Generation 1: current tracer phases only
+      pha = tr(jq)%phase                                             !--- Phases list for tr(jq)
       DO ip=1,LEN_TRIM(pha)                                          !=== LOOP ON PHASES LISTS
         trn=TRIM(tr(iq)%name); nam=trn                               !--- Tracer name (regular case)
-        IF(lTg) nam = TRIM(tr(iq)%prnt)                              !--- Parent name (tagging case)
+        IF(lTg) nam = TRIM(tr(iq)%parent)                            !--- Parent name (tagging case)
         IF(lEx) nam = TRIM(nam)//phases_sep//pha(ip:ip)              !--- Phase extension needed
         IF(lTg) nam = TRIM(nam)//'_'//TRIM(trn)                      !--- <parent>_<name> for tags
